"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class IlluminaSummaryV1(ProtocolElement):
    """
    This is the summary provided by illumina for all V1 (old version) of
    their pipeline
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "CALLABLE_AUTOSOMAL_FRACTION",
        "CNVCOUNT",
        "CNVNUMBERINGENES",
        "CNVPERCENTINGENES",
        "CNVSTATISTICSFLAG",
        "DELETIONCOUNT",
        "DELETIONNUMBERINGENES",
        "DELETIONPERCENTINGENES",
        "DELETIONS",
        "DELETIONS_HET_HOM_RATIO",
        "DELETIONS_PERCENT_FOUND_IN_DBSNP",
        "FRAGMENT_LENGTH_MAX",
        "FRAGMENT_LENGTH_MEDIAN",
        "FRAGMENT_LENGTH_MIN",
        "FRAGMENT_LENGTH_SD",
        "FRAMESHIFTDEL",
        "FRAMESHIFTINS",
        "FRAMESHIFTSNVS",
        "INDELS",
        "INDELS_PERCENT_FOUND_IN_DBSNP",
        "INDEL_HET_HOM_RATIO",
        "INSERTIONCOUNT",
        "INSERTIONNUMBERINGENES",
        "INSERTIONPERCENTINGENES",
        "INSERTIONS",
        "INSERTIONS_PERCENT_FOUND_IN_DBSNP",
        "INSERTION_HET_HOM_RATIO",
        "INVERSIONCOUNT",
        "INVERSIONNUMBERINGENES",
        "INVERSIONPERCENTINGENES",
        "MATUREMIRNADEL",
        "MATUREMIRNAINS",
        "MATUREMIRNASNVS",
        "MISMATCHRATE_R1",
        "MISMATCHRATE_R2",
        "NONSYNONYMOUSDEL",
        "NONSYNONYMOUSINS",
        "NONSYNONYMOUSSNVS",
        "NUMDELINCODINGREGIONS",
        "NUMDELINEXONS",
        "NUMDELINGENES",
        "NUMINSINCODINGREGIONS",
        "NUMINSINEXONS",
        "NUMINSINGENES",
        "NUMSNVSINCODINGREGIONS",
        "NUMSNVSINEXONS",
        "NUMSNVSINGENES",
        "PAIRED_END",
        "PERCENT_ALIGNED_R1",
        "PERCENT_ALIGNED_R2",
        "PERCENT_DUPLICATE_PAIRED_READS",
        "PERCENT_Q30_R1",
        "PERCENT_Q30_R2",
        "REFERENCE_GENOME",
        "RUNFOLDER",
        "SAMPLE_ID",
        "SMALLVARIANTSTATISTICSFLAG",
        "SNVS",
        "SNVS_ALL",
        "SNVS_PERCENT_FOUND_IN_DBSNP",
        "SNV_HET_HOM_RATIO",
        "SNV_TS_TV_RATIO",
        "SPLICESITEREGIONDEL",
        "SPLICESITEREGIONINS",
        "SPLICESITEREGIONSNVS",
        "STOPGAINEDDEL",
        "STOPGAINEDINS",
        "STOPGAINEDSNVS",
        "STOPLOSTDEL",
        "STOPLOSTINS",
        "STOPLOSTSNVS",
        "SVSTATISTICSFLAG",
        "SYNONYMOUSDEL",
        "SYNONYMOUSINS",
        "SYNONYMOUSSNVS",
        "TANDEMDUPLICATIONCOUNT",
        "TANDEMDUPLICATIONNUMBERINGENES",
        "TANDEMDUPLICATIONPERCENTINGENES",
        "TOTALNUMBERDEL",
        "TOTALNUMBERINS",
        "TOTALNUMBERSNVS",
        "UTRREGIONDEL",
        "UTRREGIONINS",
        "UTRREGIONSNVS",
        "illumina_version",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import metrics as metrics_1_2_2

        return {
            "illumina_version": metrics_1_2_2.IlluminaVersion,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import metrics as metrics_1_2_2

        return {
            "org.gel.models.report.avro.IlluminaVersion": metrics_1_2_2.IlluminaVersion,
            "org.gel.models.report.avro.IlluminaSummaryV1": metrics_1_2_2.IlluminaSummaryV1,
        }

    __slots__ = [
        "CALLABLE_AUTOSOMAL_FRACTION",
        "CNVCOUNT",
        "CNVNUMBERINGENES",
        "CNVPERCENTINGENES",
        "CNVSTATISTICSFLAG",
        "DELETIONCOUNT",
        "DELETIONNUMBERINGENES",
        "DELETIONPERCENTINGENES",
        "DELETIONS",
        "DELETIONS_HET_HOM_RATIO",
        "DELETIONS_PERCENT_FOUND_IN_DBSNP",
        "FRAGMENT_LENGTH_MAX",
        "FRAGMENT_LENGTH_MEDIAN",
        "FRAGMENT_LENGTH_MIN",
        "FRAGMENT_LENGTH_SD",
        "FRAMESHIFTDEL",
        "FRAMESHIFTINS",
        "FRAMESHIFTSNVS",
        "INDELS",
        "INDELS_PERCENT_FOUND_IN_DBSNP",
        "INDEL_HET_HOM_RATIO",
        "INSERTIONCOUNT",
        "INSERTIONNUMBERINGENES",
        "INSERTIONPERCENTINGENES",
        "INSERTIONS",
        "INSERTIONS_PERCENT_FOUND_IN_DBSNP",
        "INSERTION_HET_HOM_RATIO",
        "INVERSIONCOUNT",
        "INVERSIONNUMBERINGENES",
        "INVERSIONPERCENTINGENES",
        "MATUREMIRNADEL",
        "MATUREMIRNAINS",
        "MATUREMIRNASNVS",
        "MISMATCHRATE_R1",
        "MISMATCHRATE_R2",
        "NONSYNONYMOUSDEL",
        "NONSYNONYMOUSINS",
        "NONSYNONYMOUSSNVS",
        "NUMDELINCODINGREGIONS",
        "NUMDELINEXONS",
        "NUMDELINGENES",
        "NUMINSINCODINGREGIONS",
        "NUMINSINEXONS",
        "NUMINSINGENES",
        "NUMSNVSINCODINGREGIONS",
        "NUMSNVSINEXONS",
        "NUMSNVSINGENES",
        "PAIRED_END",
        "PERCENT_ALIGNED_R1",
        "PERCENT_ALIGNED_R2",
        "PERCENT_DUPLICATE_PAIRED_READS",
        "PERCENT_Q30_R1",
        "PERCENT_Q30_R2",
        "REFERENCE_GENOME",
        "RUNFOLDER",
        "SAMPLE_ID",
        "SMALLVARIANTSTATISTICSFLAG",
        "SNVS",
        "SNVS_ALL",
        "SNVS_PERCENT_FOUND_IN_DBSNP",
        "SNV_HET_HOM_RATIO",
        "SNV_TS_TV_RATIO",
        "SPLICESITEREGIONDEL",
        "SPLICESITEREGIONINS",
        "SPLICESITEREGIONSNVS",
        "STOPGAINEDDEL",
        "STOPGAINEDINS",
        "STOPGAINEDSNVS",
        "STOPLOSTDEL",
        "STOPLOSTINS",
        "STOPLOSTSNVS",
        "SVSTATISTICSFLAG",
        "SYNONYMOUSDEL",
        "SYNONYMOUSINS",
        "SYNONYMOUSSNVS",
        "TANDEMDUPLICATIONCOUNT",
        "TANDEMDUPLICATIONNUMBERINGENES",
        "TANDEMDUPLICATIONPERCENTINGENES",
        "TOTALNUMBERDEL",
        "TOTALNUMBERINS",
        "TOTALNUMBERSNVS",
        "UTRREGIONDEL",
        "UTRREGIONINS",
        "UTRREGIONSNVS",
        "illumina_version",
    ]

    def __init__(
        self,
        CALLABLE_AUTOSOMAL_FRACTION,
        CNVCOUNT,
        CNVNUMBERINGENES,
        CNVPERCENTINGENES,
        CNVSTATISTICSFLAG,
        DELETIONCOUNT,
        DELETIONNUMBERINGENES,
        DELETIONPERCENTINGENES,
        DELETIONS,
        DELETIONS_HET_HOM_RATIO,
        DELETIONS_PERCENT_FOUND_IN_DBSNP,
        FRAGMENT_LENGTH_MAX,
        FRAGMENT_LENGTH_MEDIAN,
        FRAGMENT_LENGTH_MIN,
        FRAGMENT_LENGTH_SD,
        FRAMESHIFTDEL,
        FRAMESHIFTINS,
        FRAMESHIFTSNVS,
        INDELS,
        INDELS_PERCENT_FOUND_IN_DBSNP,
        INDEL_HET_HOM_RATIO,
        INSERTIONCOUNT,
        INSERTIONNUMBERINGENES,
        INSERTIONPERCENTINGENES,
        INSERTIONS,
        INSERTIONS_PERCENT_FOUND_IN_DBSNP,
        INSERTION_HET_HOM_RATIO,
        INVERSIONCOUNT,
        INVERSIONNUMBERINGENES,
        INVERSIONPERCENTINGENES,
        MATUREMIRNADEL,
        MATUREMIRNAINS,
        MATUREMIRNASNVS,
        MISMATCHRATE_R1,
        MISMATCHRATE_R2,
        NONSYNONYMOUSDEL,
        NONSYNONYMOUSINS,
        NONSYNONYMOUSSNVS,
        NUMDELINCODINGREGIONS,
        NUMDELINEXONS,
        NUMDELINGENES,
        NUMINSINCODINGREGIONS,
        NUMINSINEXONS,
        NUMINSINGENES,
        NUMSNVSINCODINGREGIONS,
        NUMSNVSINEXONS,
        NUMSNVSINGENES,
        PAIRED_END,
        PERCENT_ALIGNED_R1,
        PERCENT_ALIGNED_R2,
        PERCENT_DUPLICATE_PAIRED_READS,
        PERCENT_Q30_R1,
        PERCENT_Q30_R2,
        REFERENCE_GENOME,
        RUNFOLDER,
        SAMPLE_ID,
        SMALLVARIANTSTATISTICSFLAG,
        SNVS,
        SNVS_ALL,
        SNVS_PERCENT_FOUND_IN_DBSNP,
        SNV_HET_HOM_RATIO,
        SNV_TS_TV_RATIO,
        SPLICESITEREGIONDEL,
        SPLICESITEREGIONINS,
        SPLICESITEREGIONSNVS,
        STOPGAINEDDEL,
        STOPGAINEDINS,
        STOPGAINEDSNVS,
        STOPLOSTDEL,
        STOPLOSTINS,
        STOPLOSTSNVS,
        SVSTATISTICSFLAG,
        SYNONYMOUSDEL,
        SYNONYMOUSINS,
        SYNONYMOUSSNVS,
        TANDEMDUPLICATIONCOUNT,
        TANDEMDUPLICATIONNUMBERINGENES,
        TANDEMDUPLICATIONPERCENTINGENES,
        TOTALNUMBERDEL,
        TOTALNUMBERINS,
        TOTALNUMBERSNVS,
        UTRREGIONDEL,
        UTRREGIONINS,
        UTRREGIONSNVS,
        illumina_version,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_2.IlluminaSummaryV1 model.

        :param CALLABLE_AUTOSOMAL_FRACTION:
        :type CALLABLE_AUTOSOMAL_FRACTION: double
        :param CNVCOUNT:
        :type CNVCOUNT: double
        :param CNVNUMBERINGENES:
        :type CNVNUMBERINGENES: double
        :param CNVPERCENTINGENES:
        :type CNVPERCENTINGENES: double
        :param CNVSTATISTICSFLAG:
        :type CNVSTATISTICSFLAG: str
        :param DELETIONCOUNT:
        :type DELETIONCOUNT: double
        :param DELETIONNUMBERINGENES:
        :type DELETIONNUMBERINGENES: double
        :param DELETIONPERCENTINGENES:
        :type DELETIONPERCENTINGENES: double
        :param DELETIONS:
        :type DELETIONS: double
        :param DELETIONS_HET_HOM_RATIO:
        :type DELETIONS_HET_HOM_RATIO: double
        :param DELETIONS_PERCENT_FOUND_IN_DBSNP:
        :type DELETIONS_PERCENT_FOUND_IN_DBSNP: double
        :param FRAGMENT_LENGTH_MAX:
        :type FRAGMENT_LENGTH_MAX: double
        :param FRAGMENT_LENGTH_MEDIAN:
        :type FRAGMENT_LENGTH_MEDIAN: double
        :param FRAGMENT_LENGTH_MIN:
        :type FRAGMENT_LENGTH_MIN: double
        :param FRAGMENT_LENGTH_SD:
        :type FRAGMENT_LENGTH_SD: double
        :param FRAMESHIFTDEL:
        :type FRAMESHIFTDEL: double
        :param FRAMESHIFTINS:
        :type FRAMESHIFTINS: double
        :param FRAMESHIFTSNVS:
        :type FRAMESHIFTSNVS: double
        :param INDELS:
        :type INDELS: double
        :param INDELS_PERCENT_FOUND_IN_DBSNP:
        :type INDELS_PERCENT_FOUND_IN_DBSNP: double
        :param INDEL_HET_HOM_RATIO:
        :type INDEL_HET_HOM_RATIO: double
        :param INSERTIONCOUNT:
        :type INSERTIONCOUNT: double
        :param INSERTIONNUMBERINGENES:
        :type INSERTIONNUMBERINGENES: double
        :param INSERTIONPERCENTINGENES:
        :type INSERTIONPERCENTINGENES: double
        :param INSERTIONS:
        :type INSERTIONS: double
        :param INSERTIONS_PERCENT_FOUND_IN_DBSNP:
        :type INSERTIONS_PERCENT_FOUND_IN_DBSNP: double
        :param INSERTION_HET_HOM_RATIO:
        :type INSERTION_HET_HOM_RATIO: double
        :param INVERSIONCOUNT:
        :type INVERSIONCOUNT: double
        :param INVERSIONNUMBERINGENES:
        :type INVERSIONNUMBERINGENES: double
        :param INVERSIONPERCENTINGENES:
        :type INVERSIONPERCENTINGENES: double
        :param MATUREMIRNADEL:
        :type MATUREMIRNADEL: double
        :param MATUREMIRNAINS:
        :type MATUREMIRNAINS: double
        :param MATUREMIRNASNVS:
        :type MATUREMIRNASNVS: double
        :param MISMATCHRATE_R1:
        :type MISMATCHRATE_R1: double
        :param MISMATCHRATE_R2:
        :type MISMATCHRATE_R2: double
        :param NONSYNONYMOUSDEL:
        :type NONSYNONYMOUSDEL: double
        :param NONSYNONYMOUSINS:
        :type NONSYNONYMOUSINS: double
        :param NONSYNONYMOUSSNVS:
        :type NONSYNONYMOUSSNVS: double
        :param NUMDELINCODINGREGIONS:
        :type NUMDELINCODINGREGIONS: double
        :param NUMDELINEXONS:
        :type NUMDELINEXONS: double
        :param NUMDELINGENES:
        :type NUMDELINGENES: double
        :param NUMINSINCODINGREGIONS:
        :type NUMINSINCODINGREGIONS: double
        :param NUMINSINEXONS:
        :type NUMINSINEXONS: double
        :param NUMINSINGENES:
        :type NUMINSINGENES: double
        :param NUMSNVSINCODINGREGIONS:
        :type NUMSNVSINCODINGREGIONS: double
        :param NUMSNVSINEXONS:
        :type NUMSNVSINEXONS: double
        :param NUMSNVSINGENES:
        :type NUMSNVSINGENES: double
        :param PAIRED_END:
        :type PAIRED_END: str
        :param PERCENT_ALIGNED_R1:
        :type PERCENT_ALIGNED_R1: double
        :param PERCENT_ALIGNED_R2:
        :type PERCENT_ALIGNED_R2: double
        :param PERCENT_DUPLICATE_PAIRED_READS:
        :type PERCENT_DUPLICATE_PAIRED_READS: double
        :param PERCENT_Q30_R1:
        :type PERCENT_Q30_R1: double
        :param PERCENT_Q30_R2:
        :type PERCENT_Q30_R2: double
        :param REFERENCE_GENOME:
        :type REFERENCE_GENOME: str
        :param RUNFOLDER:
        :type RUNFOLDER: str
        :param SAMPLE_ID:
        :type SAMPLE_ID: str
        :param SMALLVARIANTSTATISTICSFLAG:
        :type SMALLVARIANTSTATISTICSFLAG: str
        :param SNVS:
        :type SNVS: double
        :param SNVS_ALL:
        :type SNVS_ALL: double
        :param SNVS_PERCENT_FOUND_IN_DBSNP:
        :type SNVS_PERCENT_FOUND_IN_DBSNP: double
        :param SNV_HET_HOM_RATIO:
        :type SNV_HET_HOM_RATIO: double
        :param SNV_TS_TV_RATIO:
        :type SNV_TS_TV_RATIO: double
        :param SPLICESITEREGIONDEL:
        :type SPLICESITEREGIONDEL: double
        :param SPLICESITEREGIONINS:
        :type SPLICESITEREGIONINS: double
        :param SPLICESITEREGIONSNVS:
        :type SPLICESITEREGIONSNVS: double
        :param STOPGAINEDDEL:
        :type STOPGAINEDDEL: double
        :param STOPGAINEDINS:
        :type STOPGAINEDINS: double
        :param STOPGAINEDSNVS:
        :type STOPGAINEDSNVS: double
        :param STOPLOSTDEL:
        :type STOPLOSTDEL: double
        :param STOPLOSTINS:
        :type STOPLOSTINS: double
        :param STOPLOSTSNVS:
        :type STOPLOSTSNVS: double
        :param SVSTATISTICSFLAG:
        :type SVSTATISTICSFLAG: str
        :param SYNONYMOUSDEL:
        :type SYNONYMOUSDEL: double
        :param SYNONYMOUSINS:
        :type SYNONYMOUSINS: double
        :param SYNONYMOUSSNVS:
        :type SYNONYMOUSSNVS: double
        :param TANDEMDUPLICATIONCOUNT:
        :type TANDEMDUPLICATIONCOUNT: double
        :param TANDEMDUPLICATIONNUMBERINGENES:
        :type TANDEMDUPLICATIONNUMBERINGENES: double
        :param TANDEMDUPLICATIONPERCENTINGENES:
        :type TANDEMDUPLICATIONPERCENTINGENES: double
        :param TOTALNUMBERDEL:
        :type TOTALNUMBERDEL: double
        :param TOTALNUMBERINS:
        :type TOTALNUMBERINS: double
        :param TOTALNUMBERSNVS:
        :type TOTALNUMBERSNVS: double
        :param UTRREGIONDEL:
        :type UTRREGIONDEL: double
        :param UTRREGIONINS:
        :type UTRREGIONINS: double
        :param UTRREGIONSNVS:
        :type UTRREGIONSNVS: double
        :param illumina_version:
        :type illumina_version: IlluminaVersion
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.2"
